'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.toComponent = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utils = require('./utils');

var _renderer = require('./renderer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function toComponent(decorators) {
    decorators = decorators || [];

    function createComponent(Component, bindings) {
        bindings = bindings || {};

        var mapScopeToProps = (0, _utils.createMapScopeToProps)(bindings);

        var ComponentController = function () {
            function ComponentController($element, $injector) {
                _classCallCheck(this, ComponentController);

                this.$injector = $injector;

                this.WrappedComponent = (0, _utils.wrapWithDecorators)(this.resolveDecorators(decorators))(Component);

                this.renderer = (0, _renderer.createRenderer)(this.WrappedComponent, $element[0]);
            }

            _createClass(ComponentController, [{
                key: 'resolveDecorators',
                value: function resolveDecorators(decorators) {
                    var _this = this;

                    return decorators.map(function (decorator) {
                        return _this.$injector.invoke(decorator);
                    });
                }
            }, {
                key: '$onChanges',
                value: function $onChanges() {
                    var props = mapScopeToProps(this);

                    this.renderer.render(props);
                }
            }, {
                key: '$onDestroy',
                value: function $onDestroy() {
                    this.renderer.unmount();
                }
            }]);

            return ComponentController;
        }();

        ComponentController.$inject = ['$element', '$injector'];

        return {
            bindings: bindings,
            controller: ComponentController
        };
    };

    // Exposed for testing
    createComponent._decorators = decorators;

    return createComponent;
}

exports.toComponent = toComponent;